Name: mkinitrd-busybox
Version: 1.3.2
Release: alt1

Summary: Statically linked utilities for initrd
License: GPL
Group: System/Kernel and hardware

Packager: Sergey Vlasov <vsu@altlinux.ru>

Source: busybox-%version.tar.bz2
Source1: busybox-1.3.0-mkinitrd.config

# http://busybox.net/downloads/fixes-%version/
#Source2: fixes-%version.tar

Patch1: busybox-1.3.0-alt-no-Werror.patch
Patch2: busybox-1.3.0-alt-makefile.patch
Patch3: busybox-1.3.0-alt-insmod-allowable_licenses.patch
Patch4: busybox-1.3.0-alt-insmod-force_load.patch
Patch5: busybox-1.3.0-alt-null-format.patch
Patch6: busybox-1.3.0-alt-dietlibc.patch
Patch10: busybox-1.3.0-alt-dietlibc-loop.patch
Patch11: busybox-1.3.0-alt-bb_pwd_grp.patch

# for /lib/mkinitrd
PreReq: mkinitrd-initramfs

# due to -fno-stack-protector and getmntent_r()
BuildPreReq: dietlibc >= 0.30-alt3

# Automatically added by buildreq on Tue Jul 16 2002
BuildRequires: dietlibc

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable.  It provides replacements for most of the
utilities you usually find in GNU fileutils, shellutils, etc.  The
utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included
provide the expected functionality and behave very much like their GNU
counterparts.  BusyBox provides a fairly complete environment for any
small or embedded system.

This version of BusyBox is configured for use in initrd images generated
by the mkinitrd utility.

%prep
%setup -q -n busybox-%version
#-a 2
#for f in fixes-%version/*.patch; do
#	patch -p1 -i "$f"
#done

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch10 -p1
%patch11 -p1

cp %SOURCE1 .config

%build
%ifnarch ia64 x86_64
echo CONFIG_FEATURE_2_4_MODULES=y >> .config
echo CONFIG_FEATURE_INSMOD_VERSION_CHECKING=y >> .config
%endif

%make_build BUSYBOX_LIBS="-lcompat" CC="diet gcc" V=1

%install
install -pD -m755 busybox $RPM_BUILD_ROOT/lib/mkinitrd/busybox

%files
/lib/mkinitrd/busybox

%changelog
* Thu Feb 08 2007 Sergey Vlasov <vsu@altlinux.ru> 1.3.2-alt1
- Updated to 1.3.2 bugfix release.
- Removed obsolete fix patches.
- Require dietlibc >= 0.30-alt3 for build due to the -fno-stack-protector fix
  in the diet wrapper.
- Removed no longer needed -fno-stack-protector hack from spec file.
- Reenabled parallel make.
- Removed /lib/mkinitrd directory from package (now mkinitrd-initramfs owns
  it); require mkinitrd-initramfs before installation.
- Removed conflicts with old mkinitrd versions (the dependency on
  mkinitrd-initramfs ensures that the mkinitrd package is new enough).

* Sun Jan 21 2007 Sergey Vlasov <vsu@altlinux.ru> 1.3.0-alt2
- Moved files from /%%_lib/mkinitrd to /lib/mkinitrd (avoids arch-dependent
  paths in mkinitrd).
- Add conflicts with old mkinitrd versions which used /%%_lib/mkinitrd.

* Sun Jan 07 2007 Sergey Vlasov <vsu@altlinux.ru> 1.3.0-alt1
- Updated to 1.3.0 release.
- Apply fix patches from http://busybox.net/downloads/fixes-1.3.0/ .
- Updated alt-insmod-allowable_licenses, alt-insmod-force_load patches.
- Removed alt-mkinitrd-config patch (BUILDTIME is no longer used, CC can be set
  on the make command line instead).
- Removed alt-compiler-fixes, alt-insmod-fix, syscalls, amd64-hack patches
  (obsolete).
- Removed alt-raidautorun patch (raidautorun already included in 1.3.0)
- Updated dietlibc support patch; require dietlibc >= 0.30.
- Added alt-no-Werror patch: remove -Werror from compilation options (someone
  has inserted #warning into /usr/lib/dietlibc/include/byteswap.h).
- Added alt-makefile patch: add BUSYBOX_LIBS variable to specify extra
  libraries to link with.
- Added alt-dietlibc-loop patch: workaround for broken linux/loop.h file in
  dietlibc-0.30 (#10123).
- Added alt-bb_pwd_grp patch: do not compile internal passwd/group access
  functions when they are not enabled in config.
- Added alt-null-format patch: avoid passing NULL format strings to printf-like
  functions in verror_msg() (printf implementation in dietlibc segfaults on
  NULL format strings).
- Build with -fno-stack-protector (dietlibc-0.30 does not support SSP).
- Updated config:
  + enabled mknod and switch_root (needed for initramfs)
  + enabled sleep (#10018)
- Fixed rpmbuild warnings due to broken '%%' usage in old changelog entries.
- Removed all %%__* macro abuse from spec.

* Wed Jun 15 2005 Sergey Vlasov <vsu@altlinux.ru> 1.00.rel-alt3
- Really fix #6575 (the initial patch was fixing the case when
  CONFIG_FEATURE_2_4_MODULES was not enabled, but breaking the case when this
  option was enabled; moreover, the patch was actually not applied in %%prep).

* Tue May 24 2005 Sergey Vlasov <vsu@altlinux.ru> 1.00.rel-alt2
- insmod: fixed module option passing for 2.6.x kernels (#6575).

* Wed Feb 02 2005 Sergey Vlasov <vsu@altlinux.ru> 1.00.rel-alt1
- Updated to 1.00 release.
- Updated alt-mkinitrd-config, dietlibc patches.
- Updated config:
  + enabled ash instead of msh
  + enabled cat, umount, pivot_root

* Thu Aug 05 2004 Sergey Vlasov <vsu@altlinux.ru> 1.00.pre8-alt2
- Set CONFIG_FEATURE_CHECK_TAINTED_MODULE=y (required for GPLONLY_ symbol
  prefix support).
- Disabled parallel make (does not work).

* Mon Jul 26 2004 Kachalov Anton <mouse@altlinux.ru> 1.00.pre8-alt1
- Updated to 1.00-pre8
- Support for x86_64

* Thu Mar 11 2004 Sergey Vlasov <vsu@altlinux.ru> 0.60.5-alt1
- Package busybox for mkinitrd separately.
- Added support for loading Linux 2.6.x modules to insmod (backport from
  busybox-1.00-pre8).

* Sun Nov 09 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.9-alt3
- busybox/insmod: backported GPLONLY_ prefix support.

* Fri Oct 17 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.9-alt2
- busybox/insmod: set TAINT_FORCED_MODULE flag only when load is really forced.

* Thu Aug 28 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.9-alt1
- Updated software raid root support (Sergey Vlasov, #2082).
- Updated bootsplash support (fixes #2442).
- Updated busybox to stable-20030828.
- busybox/insmod: added more licenses to gpl compatibility list,
  to match modutils >= 2.4.15-alt1 behaviour.

* Tue Aug 12 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.8-alt1
- Added software raid root support (Sergey Vlasov).
- Enhanced modutils config parser (uses "modprobe -c").

* Fri May 02 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.7-alt2
- Updated busybox to 0.60.5, updated busybox patches.

* Mon Mar 24 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.7-alt1
- Updated mkinitrd(8).

* Wed Mar 12 2003 Peter Novodvorsky <nidd@altlinux.com> 1:2.8.6-alt2
- Increased extra initrd image size by 10%%.

* Mon Feb 10 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.6-alt1
- Added bootsplash support (rider).

* Mon Feb 03 2003 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.5-alt1
- Added --pause option (Vladimir Kholmanov <fmfm@symmetron.msk.ru>).

* Tue Oct 29 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.4-alt2
- Rebuilt with new dietlibc.

* Mon Aug 19 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.4-alt1
- Added romfs image support (goldhead).

* Tue Jul 16 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.3-alt2
- Fixed build with new dietlibc.

* Mon Apr 08 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.3-alt1
- Corrected scsimodules/ataraidmodules calculation.

* Fri Feb 22 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.2-alt1
- Copy modules with full path.

* Sat Jan 19 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.1-alt1
- Added "--debug" option for debug messages.
- Cleaned up script to avoid using /usr. 
- Updated dependencies.

* Fri Jan 18 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.8.0-alt1
- Use busybox(echo,insmod,losetup,mount,msh) as linuxrc parser.

* Fri Jan 18 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.8-alt1
- Avoid "build" symlinks.

* Wed Jan 16 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.7-alt1
- Added more module namings for new master installer.

* Tue Jan 15 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.6-alt1
- Fixed scsi autodetection for new master installer.

* Mon Jan 14 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.5-alt1
- Use ash.static as linuxrc parser.

* Wed Jan 09 2002 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.4-alt1
- Fixed pre_scsi_modules handling.

* Tue Dec 25 2001 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.3-alt1
- Fixed depmod generation for 2.4 kernels.

* Mon Dec 24 2001 Dmitry V. Levin <ldv@altlinux.org> 1:2.7.2-alt1
- Regular mkinitrd cleanup.
- Forked completely due to patch size.

* Fri Dec 14 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.7.1-alt7
- Added ataraid patch

* Fri Nov 23 2001 Dmitry V. Levin <ldv@altlinux.org> 2.7.1-alt6
- Updates package requires.

* Thu Nov 22 2001 Dmitry V. Levin <ldv@altlinux.org> 2.7.1-alt5
- Added support for nested module dependencies.

* Thu Oct 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7.1-alt4
- Updated versioned dependence on mktemp package.

* Wed Aug 22 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7.1-alt3
- Removed versioned dependence on glibc package.
- Updated versioned dependence on mktemp package.

* Tue Jul 31 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7.1-alt2
- IMAGESIZE reservation increased from 2%% to 10%% (goldhead).

* Tue Jul 24 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7.1-alt1
- Implemented ramdisk size guessing.
- Rewritten command line options parsing.

* Wed Jul 11 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7-ipl3mdk
- Added --strict option.
- Changed IGNOREMODS list.

* Mon May 07 2001 Dmitry V. Levin <ldv@altlinux.ru> 2.7-ipl2mdk
- Do not load ide-cd module.

* Sun Dec 24 2000 Dmitry V. Levin <ldv@fandra.org> 2.7-ipl1mdk
- 2.7 (added modular ide support).

* Tue Nov 28 2000 Dmitry V. Levin <ldv@fandra.org> 2.6-ipl1mdk
- 2.6
- Merged recent MDK changes into out patch.
- Added unobvious requires.

* Tue Nov 14 2000 Dmitry V. Levin <ldv@fandra.org> 2.5-ipl2mdk
- RE adaptions.

* Wed Aug 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.5-2mdk
- bug fix

* Mon Aug 21 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.5-1mdk
- update for hackkernel (new modules layout)
- remove exclusiveos:linux (rms'll be happy)
- make it noarch

* Fri Jul 28 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-3mdk
- modified the mdk patch: don't do "insmod the.o || insmod -f the.o" because
sash doesn't handle it :(

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-2mdk
- BM

* Sun Jun 25 2000 Pixel <pixel@mandrakesoft.com> 2.4.3-1mdk
- merge with redhat (mainly modules.conf by default)

* Thu Jun  1 2000 Bill Nottingham <notting@redhat.com>
- build on ia64
- bump up initrd size on ia64
- modules.confiscation, /usr/man -> /usr/share/man

* Thu May 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.3.2-16mdk
- Thanks my god initrd work on alpha !!!.

* Tue May  9 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-15mdk
- add possibility to modules to ignore via env var IGNOREMODS

* Wed May  3 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-14mdk
- patch for skipping usb-storage

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-13mdk
- add handling of non-ext2 root filesytems (again :()

* Mon Apr 17 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-12mdk
- insmod -f instead of insmod

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-11mdk
- new group

* Sun Mar 19 2000 John Buswell <johnb@mandrakesoft.com> 2.3.2-10mdk
- Added ppc and k7 arch
- Fixed bzipping of man pages

* Mon Mar 13 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-9mdk
- do not require ash.static but sash
- add requires sash >= 3.4

* Mon Mar 13 2000 Pixel <pixel@mandrakesoft.com> 2.3.2-8mdk
- add loopback handling

* Thu Jan  6 2000 Pixel <pixel@mandrakesoft.com>
- fix *buggy* grep scsi_hostadapter on conf.modules

* Mon Jan  3 2000 Pixel <pixel@mandrakesoft.com>
- fix to skip ide-scsi.o (overkill :)

* Tue Dec 28 1999 Pixel <pixel@mandrakesoft.com>
- fix to skip ppa.o and imm.o
- fix a typo

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 2.3.2.

* Tue Apr 13 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Upgrade to 2.0.

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale

* Thu Feb 25 1999 Matt Wilson <msw@redhat.com>
- updated description

* Mon Jan 11 1999 Matt Wilson <msw@redhat.com>
- Ignore the absence of scsi modules, include them if they are there, but
  don't complain if they are not.
- changed --no-scsi-modules to --omit-scsi-modules (as it should have been)

* Thu Nov  5 1998 Jeff Johnson <jbj@redhat.com>
- import from ultrapenguin 1.1.

* Tue Oct 20 1998 Jakub Jelinek <jj@ultra.linux.cz>
- fix for combined sparc/sparc64 insmod, also pluto module is really
  fc4:soc:pluto and we don't look at deps, so special case it.

* Sat Aug 29 1998 Erik Troan <ewt@redhat.com>
- replaced --needs-scsi-mods (which is now the default) with
  --omit-scsi-mods

* Fri Aug  7 1998 Jeff Johnson <jbj@redhat.com>
- correct obscure regex/shell interaction (hardwires tabs on line 232)

* Mon Jan 12 1998 Erik Troan <ewt@redhat.com>
- added 'make archive' rule to Makefile
- rewrote install procedure for more robust version handling
- be smarter about grabbing options from /etc/conf.modules

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- made it use /bin/ash.static

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Only use '-s' to install binaries if /usr/bin/strip is present.
- Use an image size of 2500 if binaries can't be stripped (1500 otherwise)
- Don't use "mount -o loop" anymore -- losetup the proper devices manually
- Requires losetup, e2fsprogs

* Wed Mar 12 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fixed a bug in parsing options.
- Changed to use a build tree, then copy the finished tree into the
  image after it is built.
- Added patches derived from ones written by Christian Hechelmann which
  add an option to put the kernel version number at the end of the module
  name and use install -s to strip binaries on the fly.
